"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Order_1 = require("./Order");
const OrderType_1 = require("../enum/OrderType");
class ExchangeStateUpdate {
    constructor(json) {
        this._nounce = json.Nounce;
        this._name = json.MarketName;
        this._placedOrders = [];
        for (let buyJson of json.Buys) {
            this._placedOrders.push(new Order_1.Order(buyJson, OrderType_1.OrderType.BUY));
        }
        for (let sellJson of json.Sells) {
            this._placedOrders.push(new Order_1.Order(sellJson, OrderType_1.OrderType.SELL));
        }
        this._fills = [];
        for (let fillJson of json.Fills) {
            this._placedOrders.push(new Order_1.Order(fillJson, json.OrderType === "BUY" ? OrderType_1.OrderType.BUY : OrderType_1.OrderType.SELL));
        }
    }
    get nounce() {
        return this._nounce;
    }
    set nounce(value) {
        this._nounce = value;
    }
    get name() {
        return this._name;
    }
    set name(value) {
        this._name = value;
    }
    get placedOrders() {
        return this._placedOrders;
    }
    set placedOrders(value) {
        this._placedOrders = value;
    }
    get fills() {
        return this._fills;
    }
    set fills(value) {
        this._fills = value;
    }
}
exports.ExchangeStateUpdate = ExchangeStateUpdate;
//# sourceMappingURL=ExchangeStateUpdate.js.map